----------------------------------------------------------
-- Example(4-9):Structural Model
-- Combinational Logic Design	
----------------------------------------------------------
library ieee;				-- component #1
use ieee.std_logic_1164.all;
entity OR_GATE is port( X, Y: in std_logic; F2: out std_logic );
end OR_GATE;
architecture behv of OR_GATE is
begin
	F2 <= X or Y;			-- behavior des.
end behv;
----------------------------------------------------------
library ieee;				-- component #2
use ieee.std_logic_1164.all;
entity AND_GATE is port(A, B: in std_logic; F1: out std_logic );
end AND_GATE;
architecture behv of AND_GATE is
begin
F1 <= A and B;			-- behavior des.
end behv;
----------------------------------------------------------
library ieee;				-- top level circuit
use ieee.std_logic_1164.all;
entity comb_ckt is
port(	input1, input2, input3: in std_logic;
			    output: out std_logic);
end comb_ckt;
architecture struct of comb_ckt is
    signal wire: std_logic;	    
begin
 G1: entity work.AND_GATE port map (input1, input2,wire);
 G2: entity work.OR_GATE port map (wire, input3, output);
end struct;
----------------------------------------------------------
